# futhark-hip

## SYNOPSIS

futhark hip [options…] <program.fut>

## DESCRIPTION

`futhark hip` translates a Futhark program to C code invoking HIP kernels, and either compiles that C code with a C compiler to an executable binary program, or produces a `.h` and `.c` file that can be linked with other code. The standard Futhark optimisation pipeline is used.

`futhark hip` uses `-lhiprtc -lamdhip64` to link. If using `--library`, you will need to do the same when linking the final binary. Although the HIP backend can be made to work on NVIDIA GPUs, you are probably better off using the very similar futhark-cuda.

## OPTIONS

Accepts the same options as futhark-c.

## ENVIRONMENT VARIABLES

`CC`

> The C compiler used to compile the program. Defaults to `cc` if unset.

`CFLAGS`

> Space-separated list of options passed to the C compiler. Defaults to `-O -std=c99` if unset.

## EXECUTABLE OPTIONS

Generated executables accept the same options as those generated by futhark-c. For commonality, the options use OpenCL nomenclature (“group” instead of “thread block”).

The following additional options are accepted.

`--default-group-size=INT`

  The default size of thread blocks that are launched. Capped to the hardware limit if necessary.

`--default-num-groups=INT`

  The default number of thread blocks that are launched.

`--default-threshold=INT`

  The default parallelism threshold used for comparisons when selecting between code versions generated by incremental flattening. Intuitively, the amount of parallelism needed to saturate the GPU.

`--default-tile-size=INT`

  The default tile size used when performing two-dimensional tiling (the workgroup size will be the square of the tile size).

`--dump-hip=FILE`

  Don’t run the program, but instead dump the embedded HIP kernels to the indicated file. Useful if you want to see what is actually being executed.

`--load-hip=FILE`

  Instead of using the embedded HIP kernels, load them from the indicated file.

`--build-option=OPT`

  Add an additional build option to the string passed to the kernel compiler (HIPRTC). Refer to the HIP documentation for which options are supported. Be careful - some options can easily result in invalid results.

## ENVIRONMENT

If run without `--library`, `futhark hip` will invoke a C compiler to compile the generated C program into a binary. This only works if the C compiler can find the necessary HIP libraries.

## SEE ALSO

futhark